VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "FlexGrid"
   ClientHeight    =   5700
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8475
   FillStyle       =   2  'Horizontal Line
   LinkTopic       =   "Form1"
   ScaleHeight     =   5700
   ScaleWidth      =   8475
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1545
      TabIndex        =   2
      Top             =   120
      Width           =   4035
   End
   Begin MSFlexGridLib.MSFlexGrid Grid 
      Height          =   5055
      Left            =   120
      TabIndex        =   0
      Top             =   480
      Width           =   8175
      _ExtentX        =   14420
      _ExtentY        =   8916
      _Version        =   327680
      Rows            =   100
      Cols            =   100
      BackColor       =   16777215
      ForeColorSel    =   -2147483628
      FocusRect       =   2
      MergeCells      =   4
      AllowUserResizing=   1
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   8130
      Top             =   -30
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
      FontSize        =   1.17491e-38
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Height          =   285
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   5475
   End
   Begin VB.Menu FileMenu 
      Caption         =   "File"
      Begin VB.Menu FileNew 
         Caption         =   "New"
      End
      Begin VB.Menu FileOpen 
         Caption         =   "Open"
      End
      Begin VB.Menu FileSave 
         Caption         =   "Save"
      End
      Begin VB.Menu FileSaveAs 
         Caption         =   "Save As"
      End
      Begin VB.Menu FileExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu EditMenu 
      Caption         =   "Edit"
      Begin VB.Menu EditCopy 
         Caption         =   "Copy"
      End
      Begin VB.Menu EditCut 
         Caption         =   "Cut"
      End
      Begin VB.Menu EditPaste 
         Caption         =   "Paste"
      End
      Begin VB.Menu EditClear 
         Caption         =   "Clear"
      End
      Begin VB.Menu EditSelect 
         Caption         =   "Select All"
      End
   End
   Begin VB.Menu FormatMenu 
      Caption         =   "Format"
      Begin VB.Menu FormatFont 
         Caption         =   "Font"
      End
      Begin VB.Menu FormatCellColor 
         Caption         =   "CellColor"
      End
      Begin VB.Menu Separator2 
         Caption         =   "-"
      End
      Begin VB.Menu FormatInteger 
         Caption         =   "###"
      End
      Begin VB.Menu Format2decimal 
         Caption         =   "###.00"
      End
      Begin VB.Menu FormatComaInteger 
         Caption         =   "#,###.00"
      End
      Begin VB.Menu FormatDollar 
         Caption         =   "$#,###.00"
      End
   End
   Begin VB.Menu MergeMenu 
      Caption         =   "Merge"
      Begin VB.Menu MergeFree 
         Caption         =   "Free Merge"
      End
      Begin VB.Menu MergeRows 
         Caption         =   "Merge Rows"
      End
      Begin VB.Menu MergeCols 
         Caption         =   "Merge Columns"
      End
      Begin VB.Menu MergeBoth 
         Caption         =   "Merge Both"
      End
      Begin VB.Menu MergeNone 
         Caption         =   "Do not Merge"
      End
   End
   Begin VB.Menu SortMenu 
      Caption         =   "Sort"
      Begin VB.Menu SortAsc 
         Caption         =   "Ascending"
         Begin VB.Menu AscNumeric 
            Caption         =   "Numeric"
         End
         Begin VB.Menu AscString 
            Caption         =   "String"
            Begin VB.Menu AscStringSensitive 
               Caption         =   "Case Sensitive"
            End
            Begin VB.Menu AscStringNonsensitive 
               Caption         =   "case insensitive"
            End
         End
         Begin VB.Menu AscGeneric 
            Caption         =   "All"
         End
      End
      Begin VB.Menu SortDesc 
         Caption         =   "Descending"
         Begin VB.Menu DescNumeric 
            Caption         =   "Numeric"
         End
         Begin VB.Menu DescString 
            Caption         =   "String"
            Begin VB.Menu DescStringSensitive 
               Caption         =   "Case Sensitive"
            End
            Begin VB.Menu DescStringNonSensitive 
               Caption         =   "case insensitive"
            End
         End
         Begin VB.Menu DescGeneric 
            Caption         =   "All"
         End
      End
   End
   Begin VB.Menu AlignMenu 
      Caption         =   "Align"
      Begin VB.Menu AlignLeft 
         Caption         =   "Align Left"
      End
      Begin VB.Menu AlignCenter 
         Caption         =   "Center"
      End
      Begin VB.Menu AlignRight 
         Caption         =   "Align Right"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim OpenFile As String

Sub NumberCells()
Dim i As Integer

    For i = 1 To Grid.Rows - 1
        Grid.TextMatrix(0, i) = Format$(i, "000")
    Next
    For i = 1 To Grid.Cols - 1
        Grid.TextMatrix(i, 0) = " " & Format$(i, "000")
    Next

End Sub

Sub FormatCells(formatString)
Dim irow, icol As Integer

    For irow = Grid.Row To Grid.RowSel
        For icol = Grid.Col To Grid.ColSel
            Grid.TextMatrix(irow, icol) = Format$(Grid.TextMatrix(irow, icol), formatString)
        Next
    Next
    
End Sub
Private Sub AlignCenter_Click()

    Grid.FillStyle = flexFillRepeat
    Grid.CellAlignment = 4
    Grid.FillStyle = flexFillSingle

End Sub

Private Sub AlignLeft_Click()

    Grid.FillStyle = flexFillRepeat
    Grid.CellAlignment = 1
    Grid.FillStyle = flexFillSingle
    
End Sub

Private Sub AlignRight_Click()

    Grid.FillStyle = flexFillRepeat
    Grid.CellAlignment = 7
    Grid.FillStyle = flexFillSingle
    
End Sub

Private Sub AscGeneric_Click()

    Grid.Sort = 1
    
End Sub

Private Sub AscNumeric_Click()

    Grid.Sort = 3
    
End Sub

Private Sub AscStringNonsensitive_Click()

    Grid.Sort = 5
    
End Sub

Private Sub AscStringSensitive_Click()

    Grid.Sort = 7
    
End Sub

Private Sub DescGeneric_Click()

    Grid.Sort = 2
    
End Sub

Private Sub DescNumeric_Click()

    Grid.Sort = 4
    
End Sub

Private Sub DescStringNonSensitive_Click()

    Grid.Sort = 6
    
End Sub

Private Sub DescStringSensitive_Click()

    Grid.Sort = 8
    
End Sub

Private Sub EditClear_Click()

    Grid.Clip = ""
    
End Sub

Private Sub EditCopy_Click()
Dim tmpText As String

    tmpText = Grid.Clip
    Clipboard.Clear
    Clipboard.Clear
    Clipboard.SetText tmpText
      
End Sub

Private Sub EditCut_Click()
Dim tmpText As String

    tmpText = Grid.Clip
    Clipboard.Clear
    Clipboard.Clear
    Clipboard.SetText tmpText
    Grid.Clip = ""
    
End Sub

Private Sub EditPaste_Click()
Dim tmpText As String

    tmpText = Clipboard.GetText
    Grid.Clip = tmpText

End Sub

Private Sub EditSelect_Click()

    Grid.Row = 1
    Grid.Col = 1
    Grid.RowSel = Grid.Rows - 1
    Grid.ColSel = Grid.Cols - 1
    
End Sub

Private Sub FileNew_Click()

    Grid.Clear
    
End Sub

Private Sub FileOpen_Click()
Dim allCells As String
Dim fnum As Integer
Dim curRow, curCol As Integer

    CommonDialog1.DefaultExt = "GDT"
    CommonDialog1.Action = 1
    If CommonDialog1.filename = "" Then Exit Sub
    fnum = FreeFile
    Open CommonDialog1.filename For Input As #fnum
    Input #fnum, allCells
    EditSelect_Click
    Grid.Clip = allCells
    Close #fnum

    Grid.Row = 1
    Grid.Col = 1
    Grid.RowSel = Grid.Row
    Grid.ColSel = Grid.Col

    NumberCells
    
End Sub

Private Sub FileSave_Click()
Dim allCells As String
Dim fnum As Integer
Dim curRow, curCol As Integer

    curRow = Grid.Row
    curCol = Grid.Col
    
    CommonDialog1.DefaultExt = "GDT"
    CommonDialog1.Action = 2
    If CommonDialog1.filename = "" Then Exit Sub
    EditSelect_Click
    allCells = Grid.Clip
    fnum = FreeFile
    Open CommonDialog1.filename For Output As #fnum
    Write #fnum, allCells
    Close #fnum
    
    Grid.Row = curRow
    Grid.Col = curCol
    Grid.RowSel = Grid.Row
    Grid.ColSel = Grid.Col

End Sub

Private Sub Form_Load()

    NumberCells
    
End Sub



Private Sub Format2decimal_Click()

    FormatCells ("###.00")
    
End Sub

Private Sub FormatCellColor_Click()

    CommonDialog1.ShowColor
    Grid.FillStyle = flexFillRepeat
    Grid.CellBackColor = CommonDialog1.Color
    Grid.FillStyle = flexFillSingle
    
    
End Sub

Private Sub FormatComaInteger_Click()

    FormatCells ("#,###.00")
    
End Sub

Private Sub FormatDollar_Click()

    FormatCells ("$#,###.00")
End Sub

Private Sub FormatFont_Click()
On Error Resume Next

    CommonDialog1.Flags = cdlCFBoth
    CommonDialog1.ShowFont
    Grid.FillStyle = flexFillRepeat
    Grid.CellFontName = CommonDialog1.FontName
    Grid.CellFontBold = CommonDialog1.FontBold
    Grid.CellFontItalic = CommonDialog1.FontItalic
    Grid.CellFontSize = CommonDialog1.FontSize
    Grid.FillStyle = flexFillSingle

End Sub

Private Sub FormatInteger_Click()
    
    FormatCells ("###")
    
End Sub

Private Sub Grid_Click()

    
    Label1.Caption = Grid.TextMatrix(Grid.Col, 0) & " : " & Grid.TextMatrix(0, Grid.Row)
    Text1.Text = Grid.Text
    Text1.SetFocus

End Sub

Private Sub Grid_EnterCell()
On Error Resume Next

    Text1.Text = Grid.Text
    Text1.SetFocus
    Text1.SelStart = 0
    Text1.SelLength = Len(Text1.Text)
    

End Sub

Private Sub Grid_LeaveCell()
    
    Grid.Text = Text1.Text

End Sub

Private Sub MergeBoth_Click()
Dim irow, icol As Integer

    For irow = Grid.Row To Grid.RowSel
        Grid.MergeRow(irow) = True
    Next
    Grid.MergeCells = 4
    
    For icol = Grid.Col To Grid.ColSel
        Grid.MergeCol(icol) = True
    Next
    Grid.MergeCells = 4
    
End Sub

Private Sub MergeCols_Click()
Dim icol As Integer

    For icol = Grid.Col To Grid.ColSel
        Grid.MergeCol(icol) = True
    Next
    Grid.MergeCells = 3

End Sub

Private Sub MergeFree_Click()
Dim irow, icol As Integer

    For irow = Grid.Row To Grid.RowSel
        Grid.MergeRow(irow) = True
    Next

    For icol = Grid.Col To Grid.ColSel
        Grid.MergeCol(icol) = True
    Next
    Grid.MergeCells = 1
    
        
End Sub

Private Sub MergeNone_Click()

    Grid.MergeCells = 0
    
End Sub

Private Sub MergeRows_Click()
Dim irow As Integer
    
    For irow = Grid.Row To Grid.RowSel
        Grid.MergeRow(irow) = True
    Next
    Grid.MergeCells = 2
    
End Sub

Private Sub Text1_KeyPress(KeyAscii As Integer)
Dim SRow, SCol As Integer

    If KeyAscii = 13 Then
        Grid.Text = Text1.Text
        SRow = Grid.Row + 1
        SCol = Grid.ColSel
        If SRow = Grid.Rows Then
            SRow = Grid.FixedCols
            If SCol < Grid.Cols - Grid.FixedCols Then SCol = SCol + 1
        End If
    
        Grid.Row = SRow
        Grid.Col = SCol
        Grid.RowSel = SRow
        Grid.ColSel = SCol
        Text1.Text = Grid.Text
        Text1.SetFocus
        KeyAscii = 0
    End If

End Sub
